From oracle-l-bounce@freelists.org  Fri Oct 22 13:23:55 2004
Return-Path: <oracle-l-bounce@freelists.org>
Received: from air189.startdedicated.com (root@localhost)
 by orafaq.com (8.11.6/8.11.6) with ESMTP id i9MINsG01345
 for <oracle-l@orafaq.com>; Fri, 22 Oct 2004 13:23:54 -0500
X-ClientAddr: 206.53.239.180
Received: from turing.freelists.org (freelists-180.iquest.net [206.53.239.180])
 by air189.startdedicated.com (8.11.6/8.11.6) with ESMTP id i9MINrI01335
 for <oracle-l@orafaq.com>; Fri, 22 Oct 2004 13:23:53 -0500
Received: from localhost (localhost [127.0.0.1])
 by turing.freelists.org (Avenir Technologies Mail Multiplex) with ESMTP
 id E513D72EB8A; Fri, 22 Oct 2004 13:30:02 -0500 (EST)
Received: from turing.freelists.org ([127.0.0.1])
 by localhost (turing [127.0.0.1]) (amavisd-new, port 10024) with ESMTP
 id 05781-45; Fri, 22 Oct 2004 13:30:02 -0500 (EST)
Received: from turing (localhost [127.0.0.1])
 by turing.freelists.org (Avenir Technologies Mail Multiplex) with ESMTP
 id 417FE72E365; Fri, 22 Oct 2004 13:30:02 -0500 (EST)
DomainKey-Signature: a=rsa-sha1; q=dns; c=nofws;
        s=beta; d=gmail.com;
        h=received:message-id:date:from:reply-to:to:subject:in-reply-to:mime-version:content-type:content-transfer-encoding:references;
        b=jxLB/O6+ejKCVjL7rXWIbPGmFPCXaKZ4aQAr3owmHi2OeHg2EQKc0JHGZNbG6/6H9OFQKZVdg4zwgEuGpzqb5RUWRAbl4iBSdgy6JUjueFqSbnE+fQrIJkJ/IG3i4/yuDQc4IyO4YEKWru8ILZBO+60qFD/oq9EXVKxx2STdabk=
Message-ID: <a8f0771c041022112812bc47f1@mail.gmail.com>
Date: Fri, 22 Oct 2004 21:28:05 +0300
From: Edgar Chupit <chupit@gmail.com>
To: "Oracle-L (E-mail)" <oracle-l@freelists.org>
Subject: Re: SORT ORDER BY elimination
In-Reply-To: <55076160AFC9C24E8D2EB831C6472BA221ECC3@MSXVS01.trivadis.com>
Mime-Version: 1.0
Content-type: text/plain; charset=US-ASCII
Content-Transfer-Encoding: 8bit
References: <55076160AFC9C24E8D2EB831C6472BA221ECC3@MSXVS01.trivadis.com>
X-archive-position: 11456
X-ecartis-version: Ecartis v1.0.0
Sender: oracle-l-bounce@freelists.org
Errors-To: oracle-l-bounce@freelists.org
X-original-sender: chupit@gmail.com
Precedence: normal
Reply-To: chupit@gmail.com
X-list: oracle-l
X-Virus-Scanned: by amavisd-new at freelists.org

Decoded message text from Peter Welker follows:

Hello Edgar,
 
you might (or better might not) want to try the NL_SJ hint inside each
subquery. This works, but is deprecated in 10g and it's slow (for your
example) since the subqueries are scanned for each sales record picked
from SALE_PK and there is no index for the subqueries.
 
Not sure if this matches you real-life problem behind the example, but
it looks a little like a reporting issue I got some time ago:
 
We required a flexible list of "dimensions" that are manually selected
and connected with large a "fact" table (only DWH speak - it actually
was OLTP). The query is not allowed to change or might become large
(no in-list) and the query results are too long for sorting, we used
temporary tables like this (converted into your example):
 
SQL> create global temporary table tmp_shops (SHOP_ID NUMBER NOT NULL)
on commit delete rows;
Table created.
SQL> create unique index i_tmp_shops on tmp_shops(shop_id);
Index created.
SQL>
SQL> create global temporary table tmp_prods (PRODUCT_ID NUMBER NOT
NULL) on commit delete rows;
Table created.
SQL> create unique index i_tmp_prods on tmp_prods(product_id);
Index created.
SQL>
SQL> insert into tmp_shops
  2   select 40 shop_id from dual union all select 20 shop_id from
dual union all select 30 shop_id from dual;
3 rows created.
SQL>
SQL> insert into tmp_prods
  2   select 140 product_id from dual union all select 40 product_id
from dual union all select 70 product_id from dual
union all select 130 product_id from dual;
4 rows created.

now try this (correlated subquery with unique index):
 
SQL> set autotrace on explain
SQL> select time, shop_id, product_id
  2  from sales sal
  3  where time between trunc(sysdate) and sysdate
  4    and shop_id in ( select * from tmp_shops s where sal.shop_id = s.shop_id)
  5    and product_id in ( select * from tmp_prods p where
sal.product_id = p.product_id)
  6  order by time, shop_id, product_id;
TIME         SHOP_ID PRODUCT_ID
--------- ---------- ----------
22-OCT-04         40        140
22-OCT-04         30        130
22-OCT-04         20         70
22-OCT-04         40         40
22-OCT-04         40        140
22-OCT-04         30        130
22-OCT-04         20         70
22-OCT-04         40         40
22-OCT-04         40        140
22-OCT-04         30        130
22-OCT-04         20         70
22-OCT-04         40         40
22-OCT-04         40        140
22-OCT-04         30        130
22-OCT-04         20         70
22-OCT-04         40         40
22-OCT-04         40        140
22-OCT-04         30        130
22-OCT-04         20         70
22-OCT-04         40         40
20 rows selected.

Execution Plan
----------------------------------------------------------
   0      SELECT STATEMENT Optimizer=ALL_ROWS (Cost=4 Card=372 Bytes=15252)
   1    0   FILTER
   2    1     NESTED LOOPS (Cost=4 Card=372 Bytes=15252)
   3    2       NESTED LOOPS (Cost=3 Card=114 Bytes=3192)
   4    3         INDEX (RANGE SCAN) OF 'SALES_PK' (UNIQUE) (Cost=3
Card=314 Bytes=4710)
   5    3         INDEX (UNIQUE SCAN) OF 'I_TMP_PRODS' (UNIQUE)
   6    2       INDEX (UNIQUE SCAN) OF 'I_TMP_SHOPS' (UNIQUE)
 
 
Of course there is an enormous overhead for filling the tmp-tables, so
this approach is only valid for situations where the subquery
selections manually takes place once for a query (or set of queries).
 
Regards & have a nice weekend
Peter


On Fri, 22 Oct 2004 20:08:22 +0200, Peter Welker
<peter.welker@trivadis.com> wrote:
> SGVsbG8gRWRnYXIsDQogDQp5b3UgbWlnaHQgKG9yIGJldHRlciBtaWdodCBub3QpIHdhbnQgdG8g
> dHJ5IHRoZSBOTF9TSiBoaW50IGluc2lkZSBlYWNoIHN1YnF1ZXJ5LiBUaGlzIHdvcmtzLCBidXQg
> 

---
  Edgar
--
http://www.freelists.org/webpage/oracle-l

